## apycula 0.8.1+dfsg

=== examples/Makefile ===
YOSYS ?= yosys
NEXTPNR ?= nextpnr-gowin

.DEFAULT_GOAL := all

include deser/Makefile

all: attosoc-tec0117.fs nanolcd-tangnano.fs blinky-tec0117.fs blinky-runber.fs \
	blinky-tangnano.fs blinky-honeycomb.fs shift-tec0117.fs shift-runber.fs \
	shift-tangnano.fs shift-honeycomb.fs \
	tonegen-tec0117.fs blinky-tangnano9k.fs blinky-tangnano1k.fs blinky-tangnano4k.fs \
	blinky-tbuf-tangnano.fs blinky-tbuf-tangnano1k.fs blinky-tbuf-tangnano4k.fs \
	blinky-tbuf-tangnano9k.fs blinky-tbuf-tec0117.fs blinky-tbuf-runber.fs \
	blinky-tbuf-honeycomb.fs \
	shift-tangnano9k.fs shift-tangnano1k.fs shift-tangnano4k.fs \
	tlvds-tangnano4k.fs tlvds-tangnano9k.fs tlvds-tec0117.fs tlvds-szfpga.fs \
	elvds-tangnano4k.fs elvds-tangnano9k.fs elvds-tec0117.fs elvds-szfpga.fs \
	elvds-tangnano.fs elvds-tangnano1k.fs \
	oddr-tlvds-tangnano4k.fs oddr-tlvds-tangnano9k.fs oddr-tlvds-tec0117.fs \
	oddr-elvds-tangnano4k.fs oddr-elvds-tangnano9k.fs oddr-elvds-tec0117.fs oddr-elvds-szfpga.fs \
	oddr-elvds-tangnano.fs oddr-elvds-tangnano1k.fs \
	blinky-oddr-tec0117.fs blinky-oddr-runber.fs \
	blinky-oddr-tangnano.fs blinky-oddr-tangnano1k.fs blinky-oddr-honeycomb.fs \
	blinky-oddr-tangnano4k.fs blinky-oddr-tangnano9k.fs \
	blinky-osc-tec0117.fs blinky-osc-runber.fs blinky-osc-tangnano.fs  \
	blinky-osc-honeycomb.fs \
	blinky-osc-tangnano9k.fs blinky-osc-tangnano1k.fs blinky-osc-tangnano4k.fs \
	pll-52-tangnano.fs pll-80-tangnano.fs \
	pll-54-tangnano1k.fs pll-81-tangnano1k.fs \
	pll-dyn-tangnano.fs pll-dyn-tangnano1k.fs \
	pll-tangnano4k.fs pll2-tangnano9k.fs pll2-tec0117.fs pll2-runber.fs pll-dyn-honeycomb.fs \
	pll-nanolcd-tangnano.fs pll-nanolcd-tangnano9k.fs \
	all_deser

unpacked: attosoc-tec0117-unpacked.v nanolcd-tangnano-unpacked.v blinky-tec0117-unpacked.v blinky-runber-unpacked.v \
	blinky-tangnano-unpacked.v blinky-honeycomb-unpacked.v shift-tec0117-unpacked.v shift-runber-unpacked.v \
	shift-tangnano-unpacked.v shift-honeycomb-unpacked.v \
	tonegen-tec0117-unpacked.v blinky-tangnano9k-unpacked.v blinky-tangnano1k-unpacked.v blinky-tangnano4k-unpacked.v \
	shift-tangnano9k-unpacked.v shift-tangnano1k-unpacked.v shift-tangnano4k-unpacked.v \
	tlvds-tangnano4k-unpacked.v tlvds-tangnano9k-unpacked.v tlvds-tec0117-unpacked.v \
	elvds-tangnano4k-unpacked.v elvds-tangnano9k-unpacked.v elvds-tec0117-unpacked.v \
	elvds-tangnano-unpacked.v elvds-tangnano1k-unpacked.v \
	blinky-tbuf-tangnano-unpacked.v blinky-tbuf-tangnano1k-unpacked.v \
	blinky-tbuf-tangnano4k-unpacked.v blinky-tbuf-tangnano9k-unpacked.v \
	blinky-tbuf-tec0117-unpacked.v blinky-tbuf-runber-unpacked.v blinky-tbuf-honeycomb-unpacked.v \
	oddr-tlvds-tangnano4k-unpacked.v oddr-tlvds-tangnano9k-unpacked.v oddr-tlvds-tec0117-unpacked.v \
	oddr-elvds-tangnano4k-unpacked.v oddr-elvds-tangnano9k-unpacked.v oddr-elvds-tec0117-unpacked.v \
	oddr-elvds-tangnano-unpacked.v oddr-elvds-tangnano1k-unpacked.v oddr-elvds-szfpga-unpacked.v \
	blinky-oddr-tec0117-unpacked.v blinky-oddr-runber-unpacked.v \
	blinky-oddr-tangnano-unpacked.v blinky-oddr-honeycomb-unpacked.v \
	blinky-oddr-tangnano-unpacked.v blinky-oddr-honeycomb-unpacked.v \
	blinky-oddr-tangnano4k-unpacked.v blinky-oddr-tangnano9k-unpacked.v \
	blinky-osc-tec0117-unpacked.v blinky-osc-runber-unpacked.v blinky-osc-tangnano-unpacked.v \
	blinky-osc-honeycomb-unpacked.v \
	blinky-osc-tangnano9k-unpacked.v blinky-osc-tangnano1k-unpacked.v blinky-osc-tangnano4k-unpacked.v \
	pll-52-tangnano-unpacked.v pll-80-tangnano-unpacked.v \
	pll-54-tangnano1k-unpacked.v pll-81-tangnano1k-unpacked.v \
	pll-dyn-tangnano-unpacked.v pll-dyn-tangnano1k-unpacked.v \
	pll2-tangnano9k-unpacked.v pll2-tec0117-unpacked.v pll2-runber-unpacked.v pll-dyn-honeycomb-unpacked.v \
	pll-nanolcd-tangnano-unpacked.v pll-nanolcd-tangnano9k-unpacked.v pll-tangnano4k-unpacked.v \
	unpacked_deser
	
clean: clean_deser
	rm -f *.json *.fs *-unpacked.v
	
.PHONY: all unpacked clean

%-tec0117.fs: %-tec0117.json
	gowin_pack -d GW1N-9 -o $@ $<

%-tec0117.json: %-tec0117-synth.json tec0117.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NR-LV9QN88C6/I5 --cst tec0117.cst

%lvds-tec0117.json: %lvds-tec0117-synth.json lvds-tec0117.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NR-LV9QN88C6/I5 --cst lvds-tec0117.cst

%-runber.fs: %-runber.json
	gowin_pack -d GW1N-4 -o $@ $<

%-runber.json: %-runber-synth.json runber.cst
	$(NEXTPNR) --json $< --write $@ --device GW1N-UV4LQ144C6/I5 --cst runber.cst

blinky-oddr-runber.json: blinky-oddr-runber-synth.json runber-tlvds.cst
	$(NEXTPNR) --json $< --write $@ --device GW1N-UV4LQ144C6/I5 --cst runber-tlvds.cst

%-tangnano.fs: %-tangnano.json
	gowin_pack -d GW1N-1 -o $@ $^

%lvds-tangnano.json: %lvds-tangnano-synth.json lvds-tangnano.cst
	$(NEXTPNR) --json $< --write $@ --device GW1N-LV1QN48C6/I5 --cst lvds-tangnano.cst

%-tangnano.json: %-tangnano-synth.json tangnano.cst
	$(NEXTPNR) --json $< --write $@ --device GW1N-LV1QN48C6/I5 --cst tangnano.cst

%-tangnano1k.fs: %-tangnano1k.json
	gowin_pack -d GW1NZ-1 -o $@ $^

%-tangnano1k.json: %-tangnano1k-synth.json tangnano1k.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NZ-LV1QN48C6/I5 --family GW1NZ-1 --cst tangnano1k.cst

%lvds-tangnano1k.json: %lvds-tangnano1k-synth.json lvds-tangnano1k.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NZ-LV1QN48C6/I5 --family GW1NZ-1 --cst lvds-tangnano1k.cst

%-tangnano4k.fs: %-tangnano4k.json
	gowin_pack -d GW1NS-4 -o $@ $^

%-tangnano4k.json: %-tangnano4k-synth.json tangnano4k.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NSR-LV4CQN48PC7/I6 --cst tangnano4k.cst

%lvds-tangnano4k.json: %lvds-tangnano4k-synth.json lvds-tangnano4k.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NSR-LV4CQN48PC7/I6 --cst lvds-tangnano4k.cst

pll-tangnano4k.json: pll-tangnano4k-synth.json tangnano4k.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NSR-LV4CQN48PC7/I6 --cst tangnano4k.cst

%-tangnano9k.fs: %-tangnano9k.json
	gowin_pack -d GW1N-9C -o $@ $^

pll-nanolcd-tangnano9k.fs: pll-nanolcd-tangnano9k.json
	gowin_pack -d GW1N-9C --sspi_as_gpio --mspi_as_gpio -o $@ $^

%-tangnano9k.json: %-tangnano9k-synth.json tangnano9k.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NR-LV9QN88PC6/I5 --family GW1N-9C --cst tangnano9k.cst

%lvds-tangnano9k.json: %lvds-tangnano9k-synth.json lvds-tangnano9k.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NR-LV9QN88PC6/I5 --family GW1N-9C --cst lvds-tangnano9k.cst

%-honeycomb.fs: %-honeycomb.json
	gowin_pack -d GW1NS-2 -o $@ $<

%-honeycomb.json: %-honeycomb-synth.json honeycomb.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NS-UX2CQN48C5/I4 --cst honeycomb.cst

attosoc-tec0117-synth.json: attosoc/attosoc.v attosoc/picorv32.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -json $@"

lutram-tec0117-synth.json: lutram/lutram.v lutram/prbs.v lutram/top.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -nolutram -json $@"

attosoc-tangnano9k-synth.json: attosoc/attosoc.v attosoc/picorv32.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -json $@"

tonegen-tec0117-synth.json: tonegen/top.v tonegen/sddac.v tonegen/cordic.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -json $@"

nanolcd-tangnano-synth.json: nanolcd/TOP.v nanolcd/VGAMod.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -noalu -json $@"

pll-nanolcd-tangnano-synth.json: pll/GW1N-1-dyn.vh pll-nanolcd/TOP.v pll-nanolcd/VGAMod.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -noalu -json $@"

pll-nanolcd-tangnano9k-synth.json: pll/GW1N-9C-dyn.vh pll-nanolcd/TOP.v pll-nanolcd/VGAMod.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -noalu -json $@"

pll2-tangnano9k-synth.json: pll/GW1N-9C-dyn.vh pll2.v pll/rpll.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -noalu -json $@"

pll2-tec0117-synth.json: pll/GW1N-9-dyn.vh pll2.v pll/rpll.v
	$(YOSYS) -D LEDS_NR=8 -D OSC_TYPE_OSC -p "read_verilog $^; synth_gowin -json $@"

pll2-runber-synth.json: pll/GW1N-4-dyn.vh pll2.v pll/rpll.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -noalu -json $@"

%-tec0117-synth.json: %.v
	$(YOSYS) -D LEDS_NR=8 -D OSC_TYPE_OSC -p "read_verilog $^; synth_gowin -json $@"

%-runber-synth.json: %.v
	$(YOSYS) -D LEDS_NR=8 -D OSC_TYPE_OSC -p "read_verilog $^; synth_gowin -json $@"

pll-%-tangnano-synth.json: pll/GW1N-1-%.vh pll.v pll/rpll.v
	$(YOSYS) -D LEDS_NR=3 -p "read_verilog $^; synth_gowin -json $@"

pll-%-tangnano1k-synth.json: pll/GW1NZ-1-%.vh pll.v pll/rpll.v
	$(YOSYS) -D LEDS_NR=3 -p "read_verilog $^; synth_gowin -json $@"

%-tangnano-synth.json: %.v
	$(YOSYS) -D LEDS_NR=3 -D OSC_TYPE_OSCH -p "read_verilog $^; synth_gowin -json $@"

%-tangnano1k-synth.json: %.v
	$(YOSYS) -D LEDS_NR=3 -D OSC_TYPE_OSCZ -p "read_verilog $^; synth_gowin -json $@"

%-tangnano4k-synth.json: %.v
	$(YOSYS) -D LEDS_NR=6 -D OSC_TYPE_OSCZ -p "read_verilog $^; synth_gowin -json $@"

pll-tangnano4k-synth.json: pll-tangnano4k.v pll/pllvr.v
	$(YOSYS) -D LEDS_NR=6 -D OSC_TYPE_OSCZ -p "read_verilog $^; synth_gowin -json $@"

%-tangnano9k-synth.json: %.v
	$(YOSYS) -D LEDS_NR=6 -D OSC_TYPE_OSC -p "read_verilog $^; synth_gowin -json $@"

pll-%-honeycomb-synth.json: pll/GW1NS-2C-%.vh pll.v pll/rpll.v
	$(YOSYS) -D LEDS_NR=3 -D OSC_TYPE_OSCF -p "read_verilog $^; synth_gowin -json $@"

%-honeycomb-synth.json: %.v
	$(YOSYS) -D LEDS_NR=3 -D OSC_TYPE_OSCF -p "read_verilog $^; synth_gowin -json $@"

%-honeycomb-prog: %-honeycomb.fs
	openFPGALoader -b honeycomb $^

%-tec0117-prog: %-tec0117.fs
	openFPGALoader -b tec0117 $^

%-runber-prog: %-runber.fs
	openFPGALoader -b runber $^

%-tangnano-prog: %-tangnano.fs
	openFPGALoader -b tangnano $^
	
%-tangnano4k-prog: %-tangnano4k.fs
	openFPGALoader -b tangnano4k $^

%-tangnano-unpacked.v: %-tangnano.fs
	gowin_unpack -d GW1N-1 -o $@ $^

%-tangnano1k-unpacked.v: %-tangnano1k.fs
	gowin_unpack -d GW1NZ-1 -o $@ $^
	
%-tangnano4k-unpacked.v: %-tangnano4k.fs
	gowin_unpack -d GW1NS-4 -o $@ $^

%-tangnano9k-unpacked.v: %-tangnano9k.fs
	gowin_unpack -d GW1N-9C -o $@ $^

%-runber-unpacked.v: %-runber.fs
	gowin_unpack -d GW1N-4 -o $@ $^

%-tec0117-unpacked.v: %-tec0117.fs
	gowin_unpack -d GW1N-9 -o $@ $^

%-honeycomb-unpacked.v: %-honeycomb.fs
	gowin_unpack -d GW1NS-2 -o $@ $<

%-szfpga-unpacked.v: %-szfpga.fs
	gowin_unpack -d GW1N-9 -o $@ $^

%lvds-szfpga.json: %lvds-szfpga-synth.json lvds-szfpga.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NR-LV9LQ144PC6/I5 --cst lvds-szfpga.cst

%-szfpga-synth.json: %.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -json $@"

%-szfpga.fs: %-szfpga.json
	gowin_pack -d GW1N-9 -o $@ $<

#############
# long wires
%-lw-tangnano.json: %-tangnano-synth.json longwires/tangnano.cst
	$(NEXTPNR) --json $< --write $@ --device GW1N-LV1QN48C6/I5 --cst longwires/tangnano.cst

%-lw-tangnano1k.json: %-tangnano1k-synth.json longwires/tangnano1k.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NZ-LV1QN48C6/I5 --family GW1NZ-1 --cst longwires/tangnano1k.cst

%-lw-tangnano4k.json: %-tangnano4k-synth.json longwires/tangnano4k.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NSR-LV4CQN48PC7/I6 --cst longwires/tangnano4k.cst

%-lw-tangnano9k.json: %-tangnano9k-synth.json longwires/tangnano9k.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NR-LV9QN88PC6/I5 --family GW1N-9C --cst longwires/tangnano9k.cst

%-lw-runber.json: %-runber-synth.json longwires/runber.cst
	$(NEXTPNR) --json $< --write $@ --device GW1N-UV4LQ144C6/I5 --cst longwires/runber.cst

%-lw-tec0117.json: %-tec0117-synth.json longwires/tec0117.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NR-LV9QN88C6/I5 --cst longwires/tec0117.cst

%-lw-honeycomb.json: %-honeycomb-synth.json longwires/honeycomb.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NS-UX2CQN48C5/I4 --cst longwires/honeycomb.cst

=== debian/changelog ===
apycula (0.8.1+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #1037306)

 -- Daniel Gröber <dxld@darkboxed.org>  Sat, 10 Jun 2023 21:43:25 +0200

## apycula 0.10.0%2Bdfsg1

=== examples/deser/Makefile ===
YOSYS ?= yosys
NEXTPNR ?= nextpnr-gowin

WRK_PATH = deser

all_deser: deser-oser4-tangnano.fs deser-oser8-tangnano.fs \
	deser-ovideo-tangnano.fs deser-oser10-tangnano.fs \
	deser-oser4-tangnano4k.fs deser-ovideo-tangnano4k.fs deser-oser8-tangnano4k.fs \
	deser-oser10-tangnano4k.fs deser-oser4-tangnano9k.fs deser-ovideo-tangnano9k.fs \
	deser-oser8-tangnano9k.fs deser-oser10-tangnano9k.fs \
	deser-oser4-szfpga.fs deser-ovideo-szfpga.fs deser-oser8-szfpga.fs \
	deser-oser10-szfpga.fs \
	deser-oser8-tlvds-tangnano4k.fs deser-ovideo-tlvds-tangnano4k.fs \
	deser-oser10-tlvds-tangnano4k.fs deser-oser4-tlvds-tangnano4k.fs \
	deser-oser8-tlvds-tangnano9k.fs deser-ovideo-tlvds-tangnano9k.fs \
	deser-oser10-tlvds-tangnano9k.fs deser-oser4-tlvds-tangnano9k.fs \
	deser-oser8-tlvds-tec0117.fs deser-ovideo-tlvds-tec0117.fs \
	deser-oser10-tlvds-tec0117.fs deser-oser4-tlvds-tec0117.fs \
	deser-ides4-tangnano.fs deser-ivideo-tangnano.fs deser-ides10-tangnano.fs \
	deser-ides8-tangnano.fs \
	deser-ides4-tangnano1k.fs deser-ivideo-tangnano1k.fs deser-ides10-tangnano1k.fs \
	deser-ides8-tangnano1k.fs \
	deser-ides4-tangnano4k.fs deser-ivideo-tangnano4k.fs deser-ides10-tangnano4k.fs \
	deser-ides8-tangnano4k.fs \
	deser-ides4-tangnano9k.fs deser-ivideo-tangnano9k.fs deser-ides10-tangnano9k.fs \
	deser-ides8-tangnano9k.fs \
	deser-ides4-szfpga.fs deser-ivideo-szfpga.fs deser-ides10-szfpga.fs \
	deser-ides8-szfpga.fs \
	deser-iddr-tangnano.fs deser-iddrc-tangnano.fs \
	deser-iddr-tangnano1k.fs deser-iddrc-tangnano1k.fs \
	deser-iddr-tangnano4k.fs deser-iddrc-tangnano4k.fs \
	deser-iddr-tangnano9k.fs deser-iddrc-tangnano9k.fs \
	deser-iddr-szfpga.fs deser-iddrc-szfpga.fs \
	deser-oser16-tangnano4k.fs deser-oser16-tangnano9k.fs deser-oser16-szfpga.fs \
	deser-ides16-tangnano4k.fs deser-ides16-tangnano9k.fs deser-ides16-szfpga.fs

unpacked_deser:	deser-oser4-tangnano-unpacked.v deser-oser8-tangnano-unpacked.v \
	deser-ovideo-tangnano-unpacked.v deser-oser10-tangnano-unpacked.v \
	deser-oser4-tangnano4k-unpacked.v deser-ovideo-tangnano4k-unpacked.v \
	deser-oser8-tangnano4k-unpacked.v deser-oser10-tangnano4k-unpacked.v \
	deser-oser4-tangnano9k-unpacked.v deser-ovideo-tangnano9k-unpacked.v \
	deser-oser8-tangnano9k-unpacked.v deser-oser10-tangnano9k-unpacked.v \
	deser-oser4-szfpga-unpacked.v deser-ovideo-szfpga-unpacked.v \
	deser-oser8-szfpga-unpacked.v deser-oser10-szfpga-unpacked.v \
	deser-oser8-tlvds-tangnano4k-unpacked.v deser-ovideo-tlvds-tangnano4k-unpacked.v \
	deser-oser10-tlvds-tangnano4k-unpacked.v deser-oser4-tlvds-tangnano4k-unpacked.v \
	deser-oser8-tlvds-tangnano9k-unpacked.v deser-ovideo-tlvds-tangnano9k-unpacked.v \
	deser-oser10-tlvds-tangnano9k-unpacked.v deser-oser4-tlvds-tangnano9k-unpacked.v \
	deser-oser8-tlvds-tec0117-unpacked.v deser-ovideo-tlvds-tec0117-unpacked.v \
	deser-oser10-tlvds-tec0117-unpacked.v deser-oser4-tlvds-tec0117-unpacked.v \
	deser-ides4-tangnano-unpacked.v deser-ivideo-tangnano-unpacked.v \
	deser-ides10-tangnano-unpacked.v deser-ides8-tangnano-unpacked.v \
	deser-ides4-tangnano1k-unpacked.v deser-ivideo-tangnano1k-unpacked.v \
	deser-ides10-tangnano1k-unpacked.v deser-ides8-tangnano1k-unpacked.v \
	deser-ides4-tangnano4k-unpacked.v deser-ivideo-tangnano4k-unpacked.v \
	deser-ides10-tangnano4k-unpacked.v deser-ides8-tangnano4k-unpacked.v \
	deser-ides4-tangnano9k-unpacked.v deser-ivideo-tangnano9k-unpacked.v \
	deser-ides10-tangnano9k-unpacked.v deser-ides8-tangnano9k-unpacked.v \
	deser-ides4-szfpga-unpacked.v deser-ivideo-szfpga-unpacked.v \
	deser-ides10-szfpga-unpacked.v deser-ides8-szfpga-unpacked.v \
	deser-iddr-tangnano-unpacked.v deser-iddrc-tangnano-unpacked.v \
	deser-iddr-tangnano1k-unpacked.v deser-iddrc-tangnano1k-unpacked.v \
	deser-iddr-tangnano4k-unpacked.v deser-iddrc-tangnano4k-unpacked.v \
	deser-iddr-tangnano9k-unpacked.v deser-iddrc-tangnano9k-unpacked.v \
	deser-iddr-szfpga-unpacked.v deser-iddrc-szfpga-unpacked.v \
	deser-oser16-tangnano4k-unpacked.v deser-oser16-tangnano9k-unpacked.v \
	deser-oser16-tangnano4k-unpacked.v \
	deser-ides16-tangnano4k-unpacked.v deser-ides16-tangnano9k-unpacked.v deser-ides16-szfpga-unpacked.v

clean_deser: 
	
.PHONY: all-deser unpacked-deser clean-deser

deser-%-tec0117.json: deser-%-tec0117-synth.json $(WRK_PATH)/%-tec0117.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NR-LV9QN88C6/I5 --cst $(WRK_PATH)/$*-tec0117.cst

deser-%-tec0117-synth.json: $(WRK_PATH)/%.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -json $@"

deser-%-tangnano.json: deser-%-tangnano-synth.json $(WRK_PATH)/%-tangnano.cst
	$(NEXTPNR) --json $< --write $@ --device GW1N-LV1QN48C6/I5 --cst $(WRK_PATH)/$*-tangnano.cst

deser-%-tangnano-synth.json: $(WRK_PATH)/%.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -json $@"

deser-%-tangnano1k.json: deser-%-tangnano1k-synth.json $(WRK_PATH)/%-tangnano1k.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NZ-LV1QN48C6/I5 --family GW1NZ-1 --cst $(WRK_PATH)/$*-tangnano1k.cst

deser-%-tangnano1k-synth.json: $(WRK_PATH)/%.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -json $@"

deser-%-tangnano4k.json: deser-%-tangnano4k-synth.json $(WRK_PATH)/%-tangnano4k.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NSR-LV4CQN48PC7/I6 --cst $(WRK_PATH)/$*-tangnano4k.cst

deser-%-tangnano4k-synth.json: $(WRK_PATH)/%.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -json $@"

deser-%-tangnano9k.json: deser-%-tangnano9k-synth.json $(WRK_PATH)/%-tangnano9k.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NR-LV9QN88PC6/I5 --family GW1N-9C --cst $(WRK_PATH)/$*-tangnano9k.cst

deser-%-tangnano9k-synth.json: $(WRK_PATH)/%.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -json $@"

######################################################
%-szfpga-unpacked.v: %-szfpga.fs
	gowin_unpack -d GW1N-9 -o $@ $^

deser-%-szfpga.json: deser-%-szfpga-synth.json $(WRK_PATH)/%-szfpga.cst
	$(NEXTPNR) --json $< --write $@ --device GW1NR-LV9LQ144PC6/I5 --cst $(WRK_PATH)/$*-szfpga.cst

deser-%-szfpga-synth.json: $(WRK_PATH)/%.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -json $@"

%-szfpga.fs: %-szfpga.json
	gowin_pack -d GW1N-9 -o $@ $<

## apycula 0.10.0+dfsg1

=== Makefile ===
ifndef GOWINHOME
$(error GOWINHOME is not set. Must be location of Gowin EDA Tools)
endif

.SECONDARY:
.PHONY: all clean
all: apycula/GW1N-1.pickle apycula/GW1N-9.pickle apycula/GW1N-4.pickle \
	 apycula/GW1NS-2.pickle apycula/GW1NS-4.pickle apycula/GW1N-9C.pickle \
	 apycula/GW1NZ-1.pickle apycula/GW2A-18.pickle apycula/GW2A-18C.pickle

%.json: apycula/dat19_h4x.py
	python3 -m apycula.dat19_h4x $*

%_stage1.pickle: apycula/tiled_fuzzer.py %.json
	python3 -m apycula.tiled_fuzzer $*

%_stage2.pickle: apycula/clock_fuzzer.py %_stage1.pickle
	python3 -m apycula.clock_fuzzer $*

apycula/%.pickle: %_stage2.pickle
	gzip -c $< > $@

clean:
	rm *.json
	rm *.pickle
	rm apycula/*.pickle

=== examples/Makefile ===
--- 
+++ 
@@ -6,7 +6,8 @@
 include deser/Makefile
 
 all: attosoc-tec0117.fs nanolcd-tangnano.fs blinky-tec0117.fs blinky-runber.fs \
-	blinky-tangnano.fs blinky-honeycomb.fs shift-tec0117.fs shift-runber.fs \
+	blinky-tangnano.fs blinky-honeycomb.fs blinky-primer20k.fs \
+	shift-tec0117.fs shift-runber.fs \
 	shift-tangnano.fs shift-honeycomb.fs \
 	tonegen-tec0117.fs blinky-tangnano9k.fs blinky-tangnano1k.fs blinky-tangnano4k.fs \
 	blinky-tbuf-tangnano.fs blinky-tbuf-tangnano1k.fs blinky-tbuf-tangnano4k.fs \
@@ -65,6 +66,12 @@
 	
 .PHONY: all unpacked clean
 
+%-primer20k.fs: %-primer20k.json
+	gowin_pack -d GW2A-18 -o $@ $<
+
+%-primer20k.json: %-primer20k-synth.json primer20k.cst
+	$(NEXTPNR) --json $< --write $@ --device GW2A-LV18PG256C8/I7 --cst primer20k.cst
+
 %-tec0117.fs: %-tec0117.json
 	gowin_pack -d GW1N-9 -o $@ $<
 
@@ -160,6 +167,9 @@
 
 pll2-runber-synth.json: pll/GW1N-4-dyn.vh pll2.v pll/rpll.v
 	$(YOSYS) -p "read_verilog $^; synth_gowin -noalu -json $@"
+
+%-primer20k-synth.json: %.v
+	$(YOSYS) -D LEDS_NR=6 -D OSC_TYPE_OSC -p "read_verilog $^; synth_gowin -json $@"
 
 %-tec0117-synth.json: %.v
 	$(YOSYS) -D LEDS_NR=8 -D OSC_TYPE_OSC -p "read_verilog $^; synth_gowin -json $@"

=== debian/changelog ===
apycula (0.10.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Simon Richter <sjr@debian.org>  Fri, 09 Feb 2024 23:42:41 +0900

apycula (0.9.1+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Simon Richter <sjr@debian.org>  Sun, 01 Oct 2023 05:05:11 +0900

apycula (0.9.0+dfsg1-2) unstable; urgency=medium

  * Source-only upload (unchanged) to allow testing migration

 -- Simon Richter <sjr@debian.org>  Mon, 25 Sep 2023 22:57:01 +0900

apycula (0.9.0+dfsg1-1) unstable; urgency=medium

  * Move to electronics Section
  * Fix missing dfsg1 suffix
  * New upstream version 0.9.0+dfsg1

 -- Daniel Gröber <dxld@darkboxed.org>  Wed, 06 Sep 2023 02:32:51 +0200

=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/,\
repacksuffix=+dfsg1 \
https://pypi.debian.net/Apycula/Apycula-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## apycula 0.12+dfsg1

=== Makefile ===
--- 
+++ 
@@ -8,10 +8,7 @@
 	 apycula/GW1NS-2.pickle apycula/GW1NS-4.pickle apycula/GW1N-9C.pickle \
 	 apycula/GW1NZ-1.pickle apycula/GW2A-18.pickle apycula/GW2A-18C.pickle
 
-%.json: apycula/dat19_h4x.py
-	python3 -m apycula.dat19_h4x $*
-
-%_stage1.pickle: apycula/tiled_fuzzer.py %.json
+%_stage1.pickle: apycula/tiled_fuzzer.py
 	python3 -m apycula.tiled_fuzzer $*
 
 %_stage2.pickle: apycula/clock_fuzzer.py %_stage1.pickle
@@ -21,6 +18,6 @@
 	gzip -c $< > $@
 
 clean:
-	rm *.json
-	rm *.pickle
-	rm apycula/*.pickle
+	rm -f *.json
+	rm -f *.pickle
+	rm -f apycula/*.pickle

=== debian/changelog ===
apycula (0.12+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Simon Richter <sjr@debian.org>  Sat, 04 May 2024 21:44:51 +0900

apycula (0.11.1+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Simon Richter <sjr@debian.org>  Sat, 04 May 2024 14:35:13 +0200

## apycula 0.14+dfsg1

=== debian/changelog ===
apycula (0.14+dfsg1-2) unstable; urgency=medium

  * Team Upload.
  * Add patch to fix SyntaxWarning (Closes: #1085325).

 -- Emmanuel Arias <eamanu@debian.org>  Mon, 21 Oct 2024 21:08:14 -0300

apycula (0.14+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Simon Richter <sjr@debian.org>  Sat, 12 Oct 2024 23:27:33 +0900

## apycula 0.15%2Bdfsg1

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,10 @@
 %_stage2.pickle: apycula/clock_fuzzer.py %_stage1.pickle
 	python3 -m apycula.clock_fuzzer $*
 
-apycula/%.pickle: %_stage2.pickle
+%_stage3.pickle: apycula/find_sdram_pins.py %_stage2.pickle
+	python3 -m apycula.find_sdram_pins $*
+
+apycula/%.pickle: %_stage3.pickle
 	gzip -c $< > $@
 
 clean:

## apycula 0.15+dfsg1

=== examples/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 YOSYS ?= yosys
-NEXTPNR ?= nextpnr-gowin
+NEXTPNR ?= nextpnr-gowin --timing-allow-fail
 
 .DEFAULT_GOAL := all

=== debian/changelog ===
apycula (0.15+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version.

 -- Emmanuel Arias <eamanu@debian.org>  Sun, 01 Dec 2024 20:46:39 -0300

=== debian/control ===
Source: apycula
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Daniel Gröber <dxld@darkboxed.org>
Section: electronics
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 python3-all,
 python3-setuptools,
 python3-setuptools-scm
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/electronics-team/apycula
Vcs-Git: https://salsa.debian.org/electronics-team/apycula.git
Homepage: https://github.com/YosysHQ/apicula

Package: python3-apycula
Provides: fpga-apicula
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Description: Tools to generate Gowin FPGA bitstreams
 Project Apicula provides documentation and tools for the bitstream format
 used by Gowin GW1N series of FPGAs.
 .
 This package contains the bitstream tools, apycula python library and
 chipdb files.

## apycula 0.16+dfsg1

=== debian/changelog ===
apycula (0.16+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.16+dfsg1
  * d/copyright: Remove examples/deser/* files from Files-Excluded.
  * d/patches/fix-syntax-warning.patch: Remove patch, it was already
    fixed in upstream.
  * d/control: Add python3-crc as binary dependency (Closes: #1091427).
  * d/control: Bump Standards-Version to 4.7.2 (from 4.6.2; no further
    changes needed).
  * d/control: Add Rules-Requires-Root: no in the source stanza.

 -- Emmanuel Arias <eamanu@debian.org>  Sun, 16 Mar 2025 19:21:27 -0300

## apycula 0.17+dfsg1

=== Makefile ===
--- 
+++ 
@@ -11,13 +11,10 @@
 %_stage1.pickle: apycula/tiled_fuzzer.py
 	python3 -m apycula.tiled_fuzzer $*
 
-%_stage2.pickle: apycula/clock_fuzzer.py %_stage1.pickle
-	python3 -m apycula.clock_fuzzer $*
-
-%_stage3.pickle: apycula/find_sdram_pins.py %_stage2.pickle
+%_stage2.pickle: apycula/find_sdram_pins.py %_stage1.pickle
 	python3 -m apycula.find_sdram_pins $*
 
-apycula/%.pickle: %_stage3.pickle
+apycula/%.pickle: %_stage2.pickle
 	gzip -c $< > $@
 
 clean:

=== examples/Makefile ===
YOSYS ?= yosys
NEXTPNR ?= nextpnr-himbaechel

.DEFAULT_GOAL := all

all: \
	blinky-tangnano20k.fs shift-tangnano20k.fs blinky-tbuf-tangnano20k.fs blinky-oddr-tangnano20k.fs \
	blinky-osc-tangnano20k.fs tlvds-tangnano20k.fs elvds-tangnano20k.fs oddr-tlvds-tangnano20k.fs \
	blinky-clkdiv-tangnano20k.fs dvi-example-tangnano20k.fs blinky-clkdiv-dhcen-tangnano20k.fs \
	oddr-elvds-tangnano20k.fs pll-nanolcd-tangnano20k.fs attosoc-tangnano20k.fs \
	oser4-tangnano20k.fs ovideo-tangnano20k.fs oser8-tangnano20k.fs oser10-tangnano20k.fs \
	iddr-tangnano20k.fs iddrc-tangnano20k.fs iodelay-tangnano20k.fs \
	ides4-tangnano20k.fs ivideo-tangnano20k.fs ides8-tangnano20k.fs ides10-tangnano20k.fs \
	bsram-pROM-tangnano20k.fs bsram-SDPB-tangnano20k.fs bsram-SP-tangnano20k.fs \
	bsram-DPB-tangnano20k.fs bsram-pROMX9-tangnano20k.fs bsram-SDPX9B-tangnano20k.fs \
	bsram-SPX9-tangnano20k.fs bsram-DPX9B-tangnano20k.fs \
	femto-riscv-15-tangnano20k.fs femto-riscv-16-tangnano20k.fs femto-riscv-18-tangnano20k.fs \
	dsp-mult18x18-tangnano20k.fs dsp-mult36x36-tangnano20k.fs dsp-padd9-tangnano20k.fs dsp-padd18-tangnano20k.fs \
	dsp-mult9x9-tangnano20k.fs dsp-alu54d-tangnano20k.fs dsp-multalu18x18-tangnano20k.fs \
	dsp-multalu36x18-tangnano20k.fs dsp-multaddalu18x18-tangnano20k.fs \
	dqce-tangnano20k.fs  dcs-tangnano20k.fs \
	\
	blinky-primer20k.fs shift-primer20k.fs blinky-tbuf-primer20k.fs blinky-oddr-primer20k.fs \
	blinky-osc-primer20k.fs tlvds-primer20k.fs elvds-primer20k.fs oddr-tlvds-primer20k.fs \
	blinky-clkdiv-primer20k.fs dvi-example-primer20k.fs blinky-clkdiv-dhcen-primer20k.fs \
	oddr-elvds-primer20k.fs pll-nanolcd-primer20k.fs attosoc-primer20k.fs \
	oser4-primer20k.fs ovideo-primer20k.fs oser8-primer20k.fs oser10-primer20k.fs \
	iddr-primer20k.fs iddrc-primer20k.fs iodelay-primer20k.fs \
	ides4-primer20k.fs ivideo-primer20k.fs ides8-primer20k.fs ides10-primer20k.fs \
	bsram-pROM-primer20k.fs bsram-SDPB-primer20k.fs bsram-SP-primer20k.fs \
	bsram-DPB-primer20k.fs bsram-pROMX9-primer20k.fs bsram-SDPX9B-primer20k.fs \
	bsram-SPX9-primer20k.fs bsram-DPX9B-primer20k.fs \
	femto-riscv-15-primer20k.fs femto-riscv-16-primer20k.fs femto-riscv-18-primer20k.fs \
	dsp-mult18x18-primer20k.fs dsp-mult36x36-primer20k.fs dsp-padd9-primer20k.fs dsp-padd18-primer20k.fs \
	dsp-mult9x9-primer20k.fs dsp-alu54d-primer20k.fs dsp-multalu18x18-primer20k.fs \
	dsp-multalu36x18-primer20k.fs dsp-multaddalu18x18-primer20k.fs \
	dqce-primer20k.fs  dcs-primer20k.fs \
	\
	blinky-tangnano.fs shift-tangnano.fs blinky-tbuf-tangnano.fs blinky-oddr-tangnano.fs \
	blinky-osc-tangnano.fs elvds-tangnano.fs oddr-elvds-tangnano.fs pll-nanolcd-tangnano.fs \
	blinky-clkdiv-tangnano.fs blinky-clkdiv-dhcen-tangnano.fs \
	oser4-tangnano.fs ovideo-tangnano.fs oser8-tangnano.fs oser10-tangnano.fs \
	iddr-tangnano.fs iddrc-tangnano.fs iodelay-tangnano.fs \
	ides4-tangnano.fs ivideo-tangnano.fs ides8-tangnano.fs ides10-tangnano.fs \
	bsram-pROM-tangnano.fs bsram-SDPB-tangnano.fs bsram-DPB-tangnano.fs \
	bsram-SP-tangnano.fs bsram-pROMX9-tangnano.fs bsram-SDPX9B-tangnano.fs \
	bsram-SPX9-tangnano.fs bsram-DPX9B-tangnano.fs \
	\
	blinky-tangnano1k.fs shift-tangnano1k.fs blinky-tbuf-tangnano1k.fs blinky-oddr-tangnano1k.fs \
	blinky-osc-tangnano1k.fs elvds-tangnano1k.fs oddr-elvds-tangnano1k.fs pll-nanolcd-tangnano1k.fs \
	blinky-clkdiv-tangnano1k.fs blinky-clkdiv-dhcen-tangnano1k.fs \
	oser4-tangnano1k.fs ovideo-tangnano1k.fs oser8-tangnano1k.fs oser10-tangnano1k.fs \
	iddr-tangnano1k.fs iddrc-tangnano1k.fs iodelay-tangnano1k.fs \
	ides4-tangnano1k.fs ivideo-tangnano1k.fs ides8-tangnano1k.fs ides10-tangnano1k.fs \
	bsram-pROM-tangnano1k.fs bsram-SDPB-tangnano1k.fs bsram-DPB16-tangnano1k.fs \
	bsram-SP-tangnano1k.fs bsram-pROMX9-tangnano1k.fs bsram-SDPX9B-tangnano1k.fs \
	bsram-SPX9-tangnano1k.fs bsram-DPX9B18-tangnano1k.fs \
	dqce-tangnano1k.fs dcs-tangnano1k.fs userflash-tangnano1k.fs bandgap-tangnano1k.fs \
	\
	blinky-tangnano4k.fs shift-tangnano4k.fs blinky-tbuf-tangnano4k.fs blinky-oddr-tangnano4k.fs \
	blinky-osc-tangnano4k.fs tlvds-tangnano4k.fs elvds-tangnano4k.fs oddr-tlvds-tangnano4k.fs \
	blinky-clkdiv-tangnano4k.fs blinky-clkdiv-dhcen-tangnano4k.fs \
	oddr-elvds-tangnano4k.fs blinky-pll-tangnano4k.fs oser16-tangnano4k.fs \
	oser4-tangnano4k.fs ovideo-tangnano4k.fs oser8-tangnano4k.fs oser10-tangnano4k.fs \
	iddr-tangnano4k.fs iddrc-tangnano4k.fs ides16-tangnano4k.fs \
	ides4-tangnano4k.fs ivideo-tangnano4k.fs ides8-tangnano4k.fs ides10-tangnano4k.fs \
	oser10-tlvds-tangnano4k.fs iodelay-tangnano4k.fs mipi-out-tangnano4k.fs \
	femto-riscv-15-tangnano4k.fs femto-riscv-16-tangnano4k.fs femto-riscv-18-tangnano4k.fs \
	dsp-mult18x18-tangnano4k.fs dsp-mult36x36-tangnano4k.fs dsp-padd9-tangnano4k.fs dsp-padd18-tangnano4k.fs \
	dsp-mult9x9-tangnano4k.fs dsp-alu54d-tangnano4k.fs dsp-multalu18x18-tangnano4k.fs \
	dsp-multalu36x18-tangnano4k.fs dsp-multaddalu18x18-tangnano4k.fs \
	dqce-tangnano4k.fs dcs-tangnano4k.fs emcu-blinky-tangnano4k.fs emcu-with-apb-blinky-tangnano4k.fs \
	emcu-with-apb-spi-tangnano4k.fs i3c-tangnano4k.fs mipi-out-tangnano4k.fs \
	\
	blinky-tangnano9k.fs shift-tangnano9k.fs blinky-tbuf-tangnano9k.fs blinky-oddr-tangnano9k.fs \
	blinky-clkdiv-tangnano9k.fs dvi-example-tangnano9k.fs\
	blinky-osc-tangnano9k.fs tlvds-tangnano9k.fs elvds-tangnano9k.fs oddr-tlvds-tangnano9k.fs \
	oddr-elvds-tangnano9k.fs pll-nanolcd-tangnano9k.fs oser16-tangnano9k.fs attosoc-tangnano9k.fs \
	oser4-tangnano9k.fs ovideo-tangnano9k.fs oser8-tangnano9k.fs oser10-tangnano9k.fs \
	iddr-tangnano9k.fs iddrc-tangnano9k.fs iodelay-tangnano9k.fs mipi-out-tangnano4k.fs \
	ides4-tangnano9k.fs ivideo-tangnano9k.fs ides8-tangnano9k.fs ides10-tangnano9k.fs \
	bsram-pROM-tangnano9k.fs bsram-SDPB-tangnano9k.fs bsram-SP-tangnano9k.fs \
	bsram-DPB-tangnano9k.fs bsram-pROMX9-tangnano9k.fs bsram-SDPX9B-tangnano9k.fs \
	bsram-SPX9-tangnano9k.fs bsram-DPX9B-tangnano9k.fs \
	oser10-elvds-tangnano9k.fs \
	femto-riscv-15-tangnano9k.fs femto-riscv-16-tangnano9k.fs femto-riscv-18-tangnano9k.fs \
	dsp-mult18x18-tangnano9k.fs dsp-mult36x36-tangnano9k.fs dsp-padd9-tangnano9k.fs dsp-padd18-tangnano9k.fs \
	dsp-mult9x9-tangnano9k.fs dsp-alu54d-tangnano9k.fs dsp-multalu18x18-tangnano9k.fs \
	dsp-multalu36x18-tangnano9k.fs dsp-multaddalu18x18-tangnano9k.fs \
	dqce-tangnano9k.fs dcs-tangnano9k.fs femto-riscv-userflash-tangnano9k.fs \
	i3c-tangnano9k.fs mipi-tangnano9k.fs mipi-out-tangnano9k.fs \
	\
	blinky-szfpga.fs shift-szfpga.fs blinky-tbuf-szfpga.fs blinky-oddr-szfpga.fs \
	blinky-osc-szfpga.fs tlvds-szfpga.fs elvds-szfpga.fs oddr-tlvds-szfpga.fs \
	blinky-clkdiv-szfpga.fs blinky-clkdiv-dhcen-szfpga.fs \
	oddr-elvds-szfpga.fs blinky-pll-szfpga.fs oser16-szfpga.fs attosoc-szfpga.fs \
	oser4-szfpga.fs ovideo-szfpga.fs oser8-szfpga.fs oser10-szfpga.fs \
	iddr-szfpga.fs iddrc-szfpga.fs ides16-szfpga.fs iodelay-szfpga.fs \
	ides4-szfpga.fs ivideo-szfpga.fs ides8-szfpga.fs ides10-szfpga.fs \
	bsram-pROM-szfpga.fs bsram-SDPB-szfpga.fs bsram-SP-szfpga.fs \
	bsram-pROMX9-szfpga.fs bsram-SDPX9B-szfpga.fs \
	bsram-SPX9-szfpga.fs \
	femto-riscv-15-szfpga.fs femto-riscv-16-szfpga.fs femto-riscv-18-szfpga.fs \
	dsp-mult18x18-szfpga.fs dsp-mult36x36-szfpga.fs dsp-padd9-szfpga.fs dsp-padd18-szfpga.fs \
	dsp-mult9x9-szfpga.fs dsp-alu54d-szfpga.fs dsp-multalu18x18-szfpga.fs \
	dsp-multalu36x18-szfpga.fs dsp-multaddalu18x18-szfpga.fs \
	\
	blinky-tec0117.fs shift-tec0117.fs blinky-tbuf-tec0117.fs blinky-oddr-tec0117.fs \
	blinky-osc-tec0117.fs tlvds-tec0117.fs elvds-tec0117.fs oddr-tlvds-tec0117.fs \
	blinky-clkdiv-tec0117.fs blinky-clkdiv-dhcen-tec0117.fs \
	oddr-elvds-tec0117.fs blinky-pll-tec0117.fs oser16-tec0117.fs attosoc-tec0117.fs \
	oser4-tec0117.fs ovideo-tec0117.fs oser8-tec0117.fs oser10-tec0117.fs \
	iddr-tec0117.fs iddrc-tec0117.fs ides16-tec0117.fs iodelay-tec0117.fs \
	ides4-tec0117.fs ivideo-tec0117.fs ides8-tec0117.fs ides10-tec0117.fs \
	dsp-mult18x18-tec0117.fs dsp-mult36x36-tec0117.fs dsp-padd9-tec0117.fs dsp-padd18-tec0117.fs \
	dsp-mult9x9-tec0117.fs dsp-alu54d-tec0117.fs dsp-multalu18x18-tec0117.fs \
	dsp-multalu36x18-tec0117.fs dsp-multaddalu18x18-tec0117.fs \
	\
	blinky-runber.fs shift-runber.fs blinky-tbuf-runber.fs blinky-oddr-runber.fs \
	blinky-osc-runber.fs tlvds-runber.fs elvds-runber.fs oddr-tlvds-runber.fs \
	blinky-clkdiv-runber.fs \
	oddr-elvds-runber.fs blinky-pll-runber.fs \
	oser4-runber.fs ovideo-runber.fs oser8-runber.fs oser10-runber.fs \
	iddr-runber.fs iddrc-runber.fs iodelay-runber.fs \
	ides4-runber.fs ivideo-runber.fs ides8-runber.fs ides10-runber.fs \
	dsp-mult36x36-runber.fs dsp-padd9-runber.fs dsp-padd18-runber.fs \
	dsp-mult9x9-runber.fs dsp-alu54d-runber.fs dsp-multalu18x18-runber.fs \
	dsp-multalu36x18-runber.fs dsp-multaddalu18x18-runber.fs

unpacked:\
	blinky-tangnano20k-unpacked.v shift-tangnano20k-unpacked.v \
	blinky-tbuf-tangnano20k-unpacked.v blinky-oddr-tangnano20k-unpacked.v \
	blinky-osc-tangnano20k-unpacked.v tlvds-tangnano20k-unpacked.v \
	elvds-tangnano20k-unpacked.v oddr-tlvds-tangnano20k-unpacked.v \
	oddr-elvds-tangnano20k-unpacked.v pll-nanolcd-tangnano20k-unpacked.v \
	attosoc-tangnano20k-unpacked.v oser4-tangnano20k-unpacked.v ovideo-tangnano20k-unpacked.v \
	oser8-tangnano20k-unpacked.v oser10-tangnano20k-unpacked.v \
	ides4-tangnano20k-unpacked.v ivideo-tangnano20k-unpacked.v ides8-tangnano20k-unpacked.v \
	ides10-tangnano20k-unpacked.v \
	bsram-pROM-tangnano20k-unpacked.v bsram-SDPB-tangnano20k-unpacked.v bsram-SP-tangnano20k-unpacked.v \
	bsram-DPB-tangnano20k-unpacked.v bsram-pROMX9-tangnano20k-unpacked.v \
	bsram-SDPX9B-tangnano20k-unpacked.v bsram-SPX9-tangnano-unpacked.v \
	bsram-DPX9B-tangnano20k-unpacked.v \
	femto-riscv-15-tangnano20k-unpacked.v femto-riscv-16-tangnano20k-unpacked.v femto-riscv-18-tangnano20k-unpacked.v \
	\
	blinky-primer20k-unpacked.v shift-primer20k-unpacked.v blinky-tbuf-primer20k-unpacked.v \
	blinky-oddr-primer20k-unpacked.v blinky-osc-primer20k-unpacked.v tlvds-primer20k-unpacked.v \
	elvds-primer20k-unpacked.v oddr-tlvds-primer20k-unpacked.v \
	oddr-elvds-primer20k-unpacked.v pll-nanolcd-primer20k-unpacked.v attosoc-primer20k-unpacked.v \
	oser4-primer20k-unpacked.v ovideo-primer20k-unpacked.v oser8-primer20k-unpacked.v \
	oser10-primer20k-unpacked.v ides4-primer20k-unpacked.v ivideo-primer20k-unpacked.v \
	ides8-primer20k-unpacked.v ides10-primer20k-unpacked.v \
	bsram-pROM-primer20k-unpacked.v bsram-SDPB-primer20k-unpacked.v bsram-SP-primer20k-unpacked.v \
	bsram-DPB-primer20k-unpacked.v bsram-pROMX9-primer20k-unpacked.v \
	bsram-SDPX9B-primer20k-unpacked.v bsram-SPX9-tangnano-unpacked.v \
	bsram-DPX9B-primer20k-unpacked.v \
	femto-riscv-15-primer20k-unpacked.v femto-riscv-16-primer20k-unpacked.v femto-riscv-18-primer20k-unpacked.v \
	\
	blinky-tangnano-unpacked.v shift-tangnano-unpacked.v blinky-tbuf-tangnano-unpacked.v \
	blinky-oddr-tangnano-unpacked.v blinky-osc-tangnano-unpacked.v elvds-tangnano-unpacked.v \
	oddr-elvds-tangnano-unpacked.v pll-nanolcd-tangnano-unpacked.v \
	oser4-tangnano-unpacked.v ovideo-tangnano-unpacked.v oser8-tangnano-unpacked.v \
	oser10-tangnano-unpacked.v ides4-tangnano-unpacked.v ivideo-tangnano-unpacked.v \
	ides8-tangnano-unpacked.v ides10-tangnano-unpacked.v bsram-pROM-tangnano-unpacked.v \
	bsram-SDPB-tangnano-unpacked.v bsram-SP-tangnano-unpacked.v bsram-pROMX9-tangnano-unpacked.v \
	bsram-SDPX9B-tangnano-unpacked.v bsram-SPX9-tangnano-unpacked.v \
	bsram-DPB-tangnano-unpacked.v bsram-DPX9B-tangnano-unpacked.v \
	\
	blinky-tangnano1k-unpacked.v shift-tangnano1k-unpacked.v blinky-tbuf-tangnano1k-unpacked.v \
	blinky-oddr-tangnano1k-unpacked.v blinky-osc-tangnano1k-unpacked.v elvds-tangnano1k-unpacked.v \
	oddr-elvds-tangnano1k-unpacked.v pll-nanolcd-tangnano1k-unpacked.v oser4-tangnano1k-unpacked.v \
	ovideo-tangnano1k-unpacked.v oser8-tangnano1k-unpacked.v oser10-tangnano1k-unpacked.v \
	ides4-tangnano1k-unpacked.v ivideo-tangnano1k-unpacked.v ides8-tangnano1k-unpacked.v \

=== debian/changelog ===
apycula (0.17+dfsg1-1) unstable; urgency=medium

  * New upstream version 0.17+dfsg1

 -- Daniel Gröber <dxld@darkboxed.org>  Mon, 24 Mar 2025 18:16:02 +0100

=== debian/control ===
--- 
+++ 
@@ -9,19 +9,19 @@
  python3-all,
  python3-setuptools,
  python3-setuptools-scm
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/electronics-team/apycula
 Vcs-Git: https://salsa.debian.org/electronics-team/apycula.git
 Homepage: https://github.com/YosysHQ/apicula
+Rules-Requires-Root: no
 
 Package: python3-apycula
 Provides: fpga-apicula
 Architecture: all
-Depends: ${misc:Depends}, ${python3:Depends}
+Depends: ${misc:Depends}, ${python3:Depends}, python3-crc
 Description: Tools to generate Gowin FPGA bitstreams
  Project Apicula provides documentation and tools for the bitstream format
  used by Gowin GW1N series of FPGAs.
  .
  This package contains the bitstream tools, apycula python library and
  chipdb files.
-

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# This file was automatically generated by stdeb 0.10.0 at
# Sat, 10 Jun 2023 21:43:25 +0200
export PYBUILD_NAME=apycula

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_clean:
	dh_auto_clean
	rm -rf Apycula.egg-info

=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/,\
dversionmangle=auto,\
repacksuffix=+dfsg1 \
https://pypi.debian.net/Apycula/Apycula-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## apycula 0.22+dfsg1

=== Makefile ===
--- 
+++ 
@@ -4,9 +4,10 @@
 
 .SECONDARY:
 .PHONY: all clean
+
 all: apycula/GW1N-1.pickle apycula/GW1N-9.pickle apycula/GW1N-4.pickle \
-	 apycula/GW1NS-2.pickle apycula/GW1NS-4.pickle apycula/GW1N-9C.pickle \
-	 apycula/GW1NZ-1.pickle apycula/GW2A-18.pickle apycula/GW2A-18C.pickle
+	 apycula/GW1NS-4.pickle apycula/GW1N-9C.pickle apycula/GW1NZ-1.pickle \
+	 apycula/GW2A-18.pickle apycula/GW2A-18C.pickle apycula/GW5A-25A.pickle
 
 %_stage1.pickle: apycula/tiled_fuzzer.py
 	python3 -m apycula.tiled_fuzzer $*

=== examples/Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 	ides4-tangnano20k.fs ivideo-tangnano20k.fs ides8-tangnano20k.fs ides10-tangnano20k.fs \
 	bsram-pROM-tangnano20k.fs bsram-SDPB-tangnano20k.fs bsram-SP-tangnano20k.fs \
 	bsram-DPB-tangnano20k.fs bsram-pROMX9-tangnano20k.fs bsram-SDPX9B-tangnano20k.fs \
-	bsram-SPX9-tangnano20k.fs bsram-DPX9B-tangnano20k.fs \
+	bsram-SPX9-tangnano20k.fs bsram-DPX9B-tangnano20k.fs  femto-riscv-memtest-tangnano20k.fs \
 	femto-riscv-15-tangnano20k.fs femto-riscv-16-tangnano20k.fs femto-riscv-18-tangnano20k.fs \
 	dsp-mult18x18-tangnano20k.fs dsp-mult36x36-tangnano20k.fs dsp-padd9-tangnano20k.fs dsp-padd18-tangnano20k.fs \
 	dsp-mult9x9-tangnano20k.fs dsp-alu54d-tangnano20k.fs dsp-multalu18x18-tangnano20k.fs \
@@ -64,7 +64,7 @@
 	oser4-tangnano4k.fs ovideo-tangnano4k.fs oser8-tangnano4k.fs oser10-tangnano4k.fs \
 	iddr-tangnano4k.fs iddrc-tangnano4k.fs ides16-tangnano4k.fs \
 	ides4-tangnano4k.fs ivideo-tangnano4k.fs ides8-tangnano4k.fs ides10-tangnano4k.fs \
-	oser10-tlvds-tangnano4k.fs iodelay-tangnano4k.fs mipi-out-tangnano4k.fs \
+	oser10-tlvds-tangnano4k.fs iodelay-tangnano4k.fs mipi-out-tangnano4k.fs  femto-riscv-memtest-tangnano4k.fs \
 	femto-riscv-15-tangnano4k.fs femto-riscv-16-tangnano4k.fs femto-riscv-18-tangnano4k.fs \
 	dsp-mult18x18-tangnano4k.fs dsp-mult36x36-tangnano4k.fs dsp-padd9-tangnano4k.fs dsp-padd18-tangnano4k.fs \
 	dsp-mult9x9-tangnano4k.fs dsp-alu54d-tangnano4k.fs dsp-multalu18x18-tangnano4k.fs \
@@ -82,7 +82,7 @@
 	bsram-pROM-tangnano9k.fs bsram-SDPB-tangnano9k.fs bsram-SP-tangnano9k.fs \
 	bsram-DPB-tangnano9k.fs bsram-pROMX9-tangnano9k.fs bsram-SDPX9B-tangnano9k.fs \
 	bsram-SPX9-tangnano9k.fs bsram-DPX9B-tangnano9k.fs \
-	oser10-elvds-tangnano9k.fs \
+	oser10-elvds-tangnano9k.fs femto-riscv-memtest-tangnano9k.fs \
 	femto-riscv-15-tangnano9k.fs femto-riscv-16-tangnano9k.fs femto-riscv-18-tangnano9k.fs \
 	dsp-mult18x18-tangnano9k.fs dsp-mult36x36-tangnano9k.fs dsp-padd9-tangnano9k.fs dsp-padd18-tangnano9k.fs \
 	dsp-mult9x9-tangnano9k.fs dsp-alu54d-tangnano9k.fs dsp-multalu18x18-tangnano9k.fs \
@@ -170,4 +170,3 @@
 	blinky-oddr-tangnano1k-unpacked.v blinky-osc-tangnano1k-unpacked.v elvds-tangnano1k-unpacked.v \
 	oddr-elvds-tangnano1k-unpacked.v pll-nanolcd-tangnano1k-unpacked.v oser4-tangnano1k-unpacked.v \
 	ovideo-tangnano1k-unpacked.v oser8-tangnano1k-unpacked.v oser10-tangnano1k-unpacked.v \
-	ides4-tangnano1k-unpacked.v ivideo-tangnano1k-unpacked.v ides8-tangnano1k-unpacked.v \

=== examples/gw5a/Makefile ===
YOSYS ?= yosys
NEXTPNR ?= nextpnr-himbaechel

.DEFAULT_GOAL := all

all: \
	in-out-primer25k.fs in-inv-out-primer25k.fs in-or-inv-out-primer25k.fs \
	lut8-primer25k.fs big-shift-primer25k.fs


clean: 
	rm -f *.json *.fs *-unpacked.v
	
.PHONY: unpacked clean

# ============================================================
# TangPrimer25k
%-primer25k.fs: %-primer25k.json
	gowin_pack --sspi_as_gpio --cpu_as_gpio -d GW5A-25A -o $@ $<

%-primer25k.json: %-primer25k-synth.json primer25k.cst
	$(NEXTPNR) -v --debug --top top --json $< --write $@ --device GW5A-LV25MG121NES --vopt cst=primer25k.cst --vopt cpu_as_gpio --vopt sspi_as_gpio

big-shift-primer25k.json: big-shift-primer25k-synth.json big-shift-primer25k.cst
	$(NEXTPNR) -v --debug --top top --json $< --write $@ --device GW5A-LV25MG121NES --vopt cst=big-shift-primer25k.cst --vopt cpu_as_gpio --vopt sspi_as_gpio

%-primer25k-synth.json: %.v
	$(YOSYS) -p "read_verilog $^; synth_gowin -json $@ -family gw5a -noalu"

=== examples/riscv-firmware/memtest-src/Makefile ===
all: memtest16.hex memtest48.hex memtest88.hex

clean:
	rm -rf *.o *.hex *.elf

.PHONY: clean all

memtest16.hex: memtest16.bram.elf Makefile
	./firmware_words memtest16.bram.elf -ram 16384 -max_addr 16384 -out memtest16.hex

memtest48.hex: memtest48.bram.elf Makefile
	./firmware_words memtest48.bram.elf -ram 49152 -max_addr 49152 -out memtest48.hex

memtest88.hex: memtest88.bram.elf Makefile
	./firmware_words memtest88.bram.elf -ram 90112 -max_addr 90112 -out memtest88.hex

memtest16.bram.elf: memtest.o wait.o start.o bram16.ld Makefile
	riscv64-none-elf-ld memtest.o wait.o start.o -o memtest16.bram.elf -T bram16.ld -m elf32lriscv -nostdlib -Map=memtest.map

memtest48.bram.elf: memtest.o wait.o start.o bram48.ld Makefile
	riscv64-none-elf-ld memtest.o wait.o start.o -o memtest48.bram.elf -T bram48.ld -m elf32lriscv -nostdlib -Map=memtest.map

memtest88.bram.elf: memtest.o wait.o start.o bram88.ld Makefile
	riscv64-none-elf-ld memtest.o wait.o start.o -o memtest88.bram.elf -T bram88.ld -m elf32lriscv -nostdlib -Map=memtest.map
%.o: %.S
	riscv64-none-elf-as -a=$@.lst -march=rv32i -mabi=ilp32 -mno-relax $< -o $@

=== debian/changelog ===
apycula (0.22+dfsg1-1) unstable; urgency=medium

  * Update packaging for 0.22

 -- Daniel Gröber <dxld@darkboxed.org>  Sat, 28 Feb 2026 23:43:27 +0100

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,3 @@
 
 %:
 	dh $@ --with python3 --buildsystem=pybuild
-
-override_dh_auto_clean:
-	dh_auto_clean
-	rm -rf Apycula.egg-info
